//----------------------------------------------------------------------
// FILENAME: KOTH_Tundra.cs
//
// AUTHORS: RedPhoenix
//----------------------------------------------------------------------

$missionName = "KOTH_Tundra";

//----------------------------------------------------------------------
// Note: To map editors
// This is based on an object within the map, if you create
// your own KOTH map, make an object to reference to distance
// and add its path like shown.
//              MissionGroup   SimGroup    Object
$objPerimeter = "MissionGroup\\Triggers\\xKingFlag";

$dist1 = 200; // Max distance
$dist2 = 150; // Prewarn Distance

exec("multiplayerStdLib.cs");
exec("KOTHstdLib.cs");

//----------------------------------------------------------------------
function setDefaultMissionOptions()
{
	$server::TeamPlay = false;
	$server::AllowDeathmatch = true;
	$server::AllowTeamPlay = true;	

	// what can the client choose for a team
	$server::AllowTeamRed = true;
	$server::AllowTeamBlue = true;
	$server::AllowTeamYellow = false;
	$server::AllowTeamPurple = false;

	// what can the server admin choose for available teams
	$server::disableTeamRed = false;
	$server::disableTeamBlue = false;
	$server::disableTeamYellow = true;
	$server::disableTeamPurple = true;
}

//----------------------------------------------------------------------
function onMissionLoad()
{
	cdAudioCycle("Purge", "Terror", "Watching"); 
}

//----------------------------------------------------------------------
// Note*** This got called in the KOTHstdLib.cs file. Anything called upon 
//    in that file you cannot reproduce it on any of these map.cs files!!!
//----------------------------------------------------------------------
//function onMissionStart()
//{
//	marsSounds();
//}
//
//----------------------------------------------------------------------
// Name_of_Trigger Trigger Event
function KingMe::trigger::onEnter(%this, %vehicleId)
{
	%player = playerManager::vehicleIdToPlayerNum(%vehicleId);
	%player.name = getName(%player);
	%team = getTeam(playerManager::vehicleIdToPlayerNum(%vehicleId));
	// Global Variable
	if($activeKing == 1)
	{
	}
	else
	{
		playAnimSequence($objPerimeter, 0.0, 1.0 ); // Activate the flag
		Say("Everybody", 1, "" @ %player.name @ *IDMULT_CHAT_KING_CROWNED_2 @ %player.name @ "!");
		$activeKing = 1; // Simple, 1 for yes, 0 for none!
		setVehicleSpecialIdentity(%vehicleId, true, *IDSTR_TEAM_PURPLE);
		schedule("CheckBoundary(" @ %vehicleId @ ");", 2); // Start dist check every 2 secs.
		%playerNum = playerManager::vehicleIdToPlayerNum(%vehicleId);
		dataStore(%playerNum, "isKing", "Yes"); // Remember he is the new king
		dataStore(%playerNum, "crowned", getCrowns(%playerNum) + 1); // & that he has been crowned + 1

		if($server::TeamPlay == true)
		{
			// Handles team colors for crown points
			if(%team == *IDSTR_TEAM_RED)
			{
				$redCrowns++;
			}
			else if(%team == *IDSTR_TEAM_BLUE)
			{
				$blueCrowns++;
			}
			else if(%team == *IDSTR_TEAM_YELLOW)
			{
				$yellowCrowns++;
			}
			else if(%team == *IDSTR_TEAM_PURPLE)
			{
				$purpleCrowns++;
			}
		}
	}
}

//----------------------------------------------------------------------