//----------------------------------------------------------------------
// FILENAME: KOTHstdLib.cs
//
// AUTHORS: RedPhoenix
//----------------------------------------------------------------------
// GameType: KOTH ~DM\TDM
// DM Goal: Become king and stay king.
// TDM Goal: Become king, then teammates protect there king at all costs.
// Globals Variables
//----------------------------------------------------------------------
// Points System
$kingCrowns = 1;
$kingExecuted = 3;
$kingWonBattle = 4;
$killPoints = 3;
$deathPoints = 2;

//----------------------------------------------------------------------
// Keeps track for team scores (King kills a foe)
$redKingKill = 0;
$blueKingKill = 0;
$yellowKingKill = 0;
$purpleKingKill = 0;

//----------------------------------------------------------------------
// Keeps track for team scores (Someone kills the king)
$redKingDied = 0;
$blueKingDied = 0;
$yellowKingDied = 0;
$purpleKingDied = 0;

//----------------------------------------------------------------------
// Keeps track for team scores (Normal kills)
$redKills = 0;
$blueKills = 0;
$yellowKills = 0;
$purpleKills = 0;

//----------------------------------------------------------------------
// Keeps track for team scores (Normal deaths)
$redDeaths = 0;
$blueDeaths = 0;
$yellowDeaths = 0;
$purpleDeaths = 0;

//----------------------------------------------------------------------
// Keeps track for team scores (Times crowned)
$redCrowns = 0;
$blueCrowns = 0;
$yellowCrowns = 0;
$purpleCrowns = 0;

//----------------------------------------------------------------------
// Flags, etc..
$activeKing = 0;
$preWarn = 0;
$leftBoundary = 0;
$count = 5;

//----------------------------------------------------------------------
function setRules()
{
	if($server::TeamPlay != true)
	{
		%rules = "<tIDMULT_KOTH_DM_GAMETYPE>"	@
				"<tIDMULT_KOTH_DM_MAPNAME>" 	@
				$missionName			@
				"<tIDMULT_KOTH_DM_OBJECTIVES>"@
				"<tIDMULT_KOTH_SCORING_1>"	@
				"<tIDMULT_KOTH_SCORING_2>"	@
				$kingExecuted			@
				"<tIDMULT_KOTH_SCORING_3>"	@
				"<tIDMULT_KOTH_SCORING_4>"	@
				$normalDeath			@
				"<tIDMULT_KOTH_SCORING_5>"	@
				"<tIDMULT_KOTH_SCORING_6>"	@
				$kingWonBattle			@
				"<tIDMULT_KOTH_SCORING_7>"	@
				"<tIDMULT_KOTH_SCORING_8>"	@
				$kingCrowns				@
				"<tIDMULT_KOTH_SCORING_9>"	@
				"<tIDMULT_STD_ITEMS>"		@
				"<tIDMULT_STD_HEAL>"		@
				"<tIDMULT_STD_RELOAD_1>"	@
				$PadWaitTime			@
				"<tIDMULT_STD_RELOAD_2>"	@
				"<tIDMULT_STD_ZEN_1>"		@
				$ZenWaitTime			@
				"<tIDMULT_STD_ZEN_2>";
	}
	else
	{
		%rules = "<tIDMULT_KOTH_TDM_GAMETYPE>"	@
				"<tIDMULT_KOTH_TDM_MAPNAME>" 	@
				$missionName			@
				"<tIDMULT_KOTH_TDM_OBJECTIVES>"@
				"<tIDMULT_KOTH_SCORING_1>"	@
				"<tIDMULT_KOTH_SCORING_2>"	@
				$kingExecuted			@
				"<tIDMULT_KOTH_SCORING_3>"	@
				"<tIDMULT_KOTH_SCORING_4>"	@
				$normalDeath			@
				"<tIDMULT_KOTH_SCORING_5>"	@
				"<tIDMULT_KOTH_SCORING_6>"	@
				$kingWonBattle			@
				"<tIDMULT_KOTH_SCORING_7>"	@
				"<tIDMULT_KOTH_SCORING_8>"	@
				$kingCrowns				@
				"<tIDMULT_KOTH_SCORING_9>"	@
				"<tIDMULT_STD_ITEMS>"		@
				"<tIDMULT_STD_HEAL>"		@
				"<tIDMULT_STD_RELOAD_1>"	@
				$PadWaitTime			@
				"<tIDMULT_STD_RELOAD_2>"	@
				"<tIDMULT_STD_ZEN_1>"		@
				$ZenWaitTime			@
				"<tIDMULT_STD_ZEN_2>";
	}
	setGameInfo(%rules);
}

setRules();

//----------------------------------------------------------------------
function onMissionStart(%playerNum)
{
	//reinitialize scores of players who were in previous game
	%count = playerManager::getPlayerCount();

	for(%i = 0; %i < %count; %i = %i + 1)
	{
		%curPlayerNum = playerManager::getPlayerNum(%i);
		initStats(%curPlayerNum);
	}
}

//----------------------------------------------------------------------
function initStats(%playerNum)
{
	dataStore(%playerNum, "crowned",		0 );
	dataStore(%playerNum, "executedKing",	0 );
	dataStore(%playerNum, "wonBattleAsKing",	0 );
	dataStore(%playerNum, "isKing",		"No" );
	dataStore(%playerNum, "kills",		0 );
	dataStore(%playerNum, "deaths",		0 );
}

//----------------------------------------------------------------------
function player::onAdd(%playerNum)
{
	initStats(%playerNum);
	say(%playerNum, 0, *IDMULT_KOTH_DM_WELCOME);
}

//----------------------------------------------------------------------
function vehicle::onAdd(%this)
{
	if($server::TeamPlay != true)
	{
      	%player = playerManager::vehicleIdToPlayerNum(%this);
      	if(%player == 0)
         		return;
      	setTeam(%this, *IDSTR_TEAM_RED);
	}
}

//----------------------------------------------------------------------
function player::onRemove(%playerNum)
{
	if(%playerNum == getKing())
	{
		Say("Everybody", 1, *IDMULT_CHAT_KING_DEAD_THRONE_EMPTY);
		dataStore(%playerNum, "isKing", "No");
		%vehicleId = playerManager::playerNumToVehicleId(%playerNum);
		setVehicleSpecialIdentity(%vehicleId, false, *IDSTR_TEAM_PURPLE);
		$leftBoundary = 0;
		$count = 5;
		$activeKing = 0;
		$preWarn = 0;
	}
	else
	{
		// Let the game handle it.
	}
}

//----------------------------------------------------------------------
function vehicle::onDestroyed(%destroyed, %destroyer)
{
	%loser = playerManager::vehicleIdToPlayerNum(%destroyed);
	%winner = playerManager::vehicleIdToPlayerNum(%destroyer);

	%loser.name = getName(%loser); // Handle player name
	%winner.name = getName(%winner); // Handle player name

	%loser.team = getTeam(%loser); // Handle player team
	%winner.team = getTeam(%winner); // Handle player team

	if(%loser != getKing()) // If destroyed is not king
	{
		if(%loser == %winner) // Commit suicide?
		{
			Say("Everybody", 1, "" @ %loser.name @ " has committed suicide!");
			dataStore(%loser, "deaths", getPlayerDeaths(%loser) + 1);

			if($server::TeamPlay == true)
			{
				if(%loser.team == *IDSTR_TEAM_RED)
				{$redDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_BLUE)
				{$blueDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_YELLOW)
				{$yellowDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_PURPLE)
				{$purpleDeaths++;}
			}
		}
		else if(%loser != %winner) // Killed by someone else
		{
			%message = getFancyDeathMessage(getHUDName(%loser), getHUDName(%winner));
			if(%message != "")
			{
				say( 0, 0, %message);
			}
			dataStore(%loser, "deaths", getPlayerDeaths(%loser) + 1);
			dataStore(%winner, "kills", getPlayerKills(%winner) + 1);

			if($server::TeamPlay == true)
			{
				if(%loser.team == *IDSTR_TEAM_RED)
				{$redDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_BLUE)
				{$blueDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_YELLOW)
				{$yellowDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_PURPLE)
				{$purpleDeaths++;}

				if(%winner.team == *IDSTR_TEAM_RED)
				{$redKills++;}
				else if(%winner.team == *IDSTR_TEAM_BLUE)
				{$blueKills++;}
				else if(%winner.team == *IDSTR_TEAM_YELLOW)
				{$yellowKills++;}
				else if(%winner.team == *IDSTR_TEAM_PURPLE)
				{$purpleKills++;}
			}
		}
	}

	// If Destroyed was king
	if(%loser == getKing()) // Did the king die yet?
	{
		// Notify everyone
		Say("Everybody", 1, *IDMULT_CHAT_KING_DEAD_THRONE_EMPTY);
		dataStore(%loser, "isKing", "No");
		playAnimSequence($objPerimeter, 0.0, 0.0 );

		// Reset variables
		$activeKing = 0;
		$leftBoundary = 0;
		$count = 5;
		$preWarn = 0;

		// Make sure the king didn't kill himself
		if(%loser == %winner) // Make sure the king didn't chicken shit out
		{
			Say("Everybody", 1, "The king has committed suicide!");
			dataStore(%loser, "deaths", getPlayerDeaths(%loser) + 1);

			if($server::TeamPlay == true)
			{
				if(%loser.team == *IDSTR_TEAM_RED)
				{$redDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_BLUE)
				{$blueDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_YELLOW)
				{$yellowDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_PURPLE)
				{$purpleDeaths++;}
			}
		}
		else if(%loser != %winner) // Someone has overthrown him!
		{
			Say("Everybody", 1, "" @ %winner.name @ *IDMULT_CHAT_KING_KILLED_2);
			dataStore(%winner, "executedKing", getKingExecutions(%winner) + 1);
			dataStore(%loser, "deaths", getPlayerDeaths(%loser) + 1);

			if($server::TeamPlay == true)
			{
				if(%loser.team == *IDSTR_TEAM_RED)
				{$redDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_BLUE)
				{$blueDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_YELLOW)
				{$yellowDeaths++;}
				else if(%loser.team == *IDSTR_TEAM_PURPLE)
				{$purpleDeaths++;}

				if(%winner.team == *IDSTR_TEAM_RED)
				{$redKingDied++;}
				else if(%winner.team == *IDSTR_TEAM_BLUE)
				{$blueKingDied++;}
				else if(%winner.team == *IDSTR_TEAM_YELLOW)
				{$yellowKingDied++;}
				else if(%winner.team == *IDSTR_TEAM_PURPLE)
				{$purpleKingDied++;}
			}
		}

		// Stop king from glowing
		%vehicleId = playerManager::playerNumToVehicleId(%loser);
		setVehicleSpecialIdentity(%vehicleId, false, *IDSTR_TEAM_PURPLE);
	}

	// This king kicks ass, give him his points
	if((%winner == getKing()) && (%loser != getKing()))
	{
		Say("Everybody", 1, "The King " @ %winner.name @ " killed " @ %loser.name @ "!");
		%vehicleId = playerManager::playerNumToVehicleId(%winner);
		healObject(%vehicleId, 50000);
		reloadObject(%vehicleId, 100);
		dataStore(%winner, "wonBattleAsKing", getKingKills(%winner) + 1);
		dataStore(%loser, "deaths", getPlayerDeaths(%loser) + 1);

		if($server::TeamPlay == true)
		{
			if(%loser.team == *IDSTR_TEAM_RED)
			{$redDeaths++;}
			else if(%loser.team == *IDSTR_TEAM_BLUE)
			{$blueDeaths++;}
			else if(%loser.team == *IDSTR_TEAM_YELLOW)
			{$yellowDeaths++;}
			else if(%loser.team == *IDSTR_TEAM_PURPLE)
			{$purpleDeaths++;}

			if(%winner.team == *IDSTR_TEAM_RED)
			{$redKingKill++;}
			else if(%winner.team == *IDSTR_TEAM_BLUE)
			{$blueKingKill++;}
			else if(%winner.team == *IDSTR_TEAM_YELLOW)
			{$yellowKingKill++;}
			else if(%winner.team == *IDSTR_TEAM_PURPLE)
			{$purpleKingKill++;}
		}
	}
}

//----------------------------------------------------------------------
// Find if someone is king, if not then return false.
function getKing()
{
	%count = playerManager::getPlayerCount();

	for(%i = 0; %i < %count; %i++)
	{
		%temp = playerManager::getPlayerNum(%i);
		if(dataRetrieve(%temp, "isKing") == "Yes")
		{
			return %temp;
		}	
	}
	return "false";
}

//----------------------------------------------------------------------
// Check distance, is king is out of bounds, warn him first.
// If he doesn't comply, rip his title away from him.
function CheckBoundary(%vehicleId)
{
	%obj1 = getObjectId(%vehicleId);
	%obj2 = getObjectId($objPerimeter);
	%var = getDistance( %obj1, %obj2 );

	%player = playerManager::getPlayerNum(%vehicleId);

	// If king is past his boundary of 200
	if((%var > $dist1) && ($count >= 1))
	{
		Say(%player, %player, *IDMULT_CHAT_KING_TIMER_1 @ $count @ " secs!", "alarm2.wav");
		$leftBoundary = 1;
		$count -= 1;
	}

	// Prewarning at 100
	if((%var > $dist2) && ($preWarn == 0))
	{
		Say(%player, %player, *IDMULT_CHAT_KING_WARNING);
		$preWarn = 1;
	}

	// If king did return
	if((%var < $dist2) && ($leftBoundary == 1))
	{
		Say(%player, %player, *IDMULT_CHAT_KING_RETURNED );
		$leftBoundary = 0;
		$count = 5;
		$preWarn = 0;
	}

	// If king did not return
	if($count == 0)
	{
		%playerNum = playerManager::vehicleIdToPlayerNum(%vehicleId);
		dataStore(%playerNum, "isKing", "No");
		Say("Everybody", 1, *IDMULT_CHAT_KING_TOO_FAR);
		setVehicleSpecialIdentity(%vehicleId, false, *IDSTR_TEAM_PURPLE);
		$leftBoundary = 0;
		$count = 5;
		$activeKing = 0;
		$preWarn = 0;
		return 0;
	}

	// If no one is king and we are at this point, return 0
	if(getKing() == "false")
	{
		return 0;
	}
	schedule("CheckBoundary(" @ %vehicleId @ ");", 2);
}

//----------------------------------------------------------------------
function getCrowns(%playerNum)
{
	return dataRetrieve(%playerNum, "crowned");
}

//----------------------------------------------------------------------
function getKingKills(%playerNum)
{
	return dataRetrieve(%playerNum, "wonBattleAsKing");
}

//----------------------------------------------------------------------
function getKinged(%playerNum)
{
	return dataRetrieve(%playerNum, "isKing");
}

//----------------------------------------------------------------------
function getKingExecutions(%playerNum)
{
	return dataRetrieve(%playerNum, "executedKing");
}

//----------------------------------------------------------------------
function getPlayerDeaths(%playerNum)
{
	return dataRetrieve(%playerNum, "deaths");
}

//----------------------------------------------------------------------
function getPlayerKills(%playerNum)
{
	return dataRetrieve(%playerNum, "kills");
}

//----------------------------------------------------------------------
function getPlayerPoint(%playerNum)
{
	%timesCrowned = $kingCrowns * getCrowns(%playerNum);
	%executor = $kingExecuted * getKingExecutions(%playerNum);
	%kingSacks = $kingWonBattle * getKingKills(%playerNum);
	%normKill = $killPoints * getPlayerKills(%playerNum);
	%deaths = $deathPoints * getPlayerDeaths(%playerNum);

	return ((%timesCrowned + %executor + %kingSacks + %normKill) - %deaths);
	
}

//----------------------------------------------------------------------
function getPlayerSquad(%playerNum)
{
	%player = playerManager::playerNumToVehicleId(%playerNum);
	return getSquad(%playerNum);
}

//----------------------------------------------------------------------
function getTeamSquadKills(%team)
{
	if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_RED)
	{
		return $redKills;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_BLUE)
	{
		return $blueKills;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_YELLOW)
	{
		return $yellowKills;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_PURPLE)
	{
		return $purpleKills;
	}
}

//----------------------------------------------------------------------
function getTeamCrowns(%team)
{
	if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_RED)
	{
		return $redCrowns;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_BLUE)
	{
		return $blueCrowns;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_YELLOW)
	{
		return $yellowCrowns;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_PURPLE)
	{
		return $purpleCrowns;
	}
}

//----------------------------------------------------------------------
function getTeamSquadDeaths(%team)
{
	if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_RED)
	{
		return $redDeaths;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_BLUE)
	{
		return $blueDeaths;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_YELLOW)
	{
		return $yellowDeaths;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_PURPLE)
	{
		return $purpleDeaths;
	}
}

//----------------------------------------------------------------------
function getTeamKingKills(%team)
{
	if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_RED)
	{
		return $redKingDied;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_BLUE)
	{
		return $blueKingDied;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_YELLOW)
	{
		return $yellowKingDied;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_PURPLE)
	{
		return $purpleKingDied;
	}
}

//----------------------------------------------------------------------
function getTeamKingWins(%team)
{
	if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_RED)
	{
		return $redKingKill;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_BLUE)
	{
		return $blueKingKill;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_YELLOW)
	{
		return $yellowKingKill;
	}
	else if(getTeamNameFromTeamId(%team) == *IDSTR_TEAM_PURPLE)
	{
		return $purpleKingKill;
	}
}

//----------------------------------------------------------------------
function getTeamSquadPoints(%team)
{
	%kill = getTeamSquadKills(%team) * $killPoints;
	%crown = getTeamCrowns(%team) * $kingCrowns;
	%death = getTeamSquadDeaths(%team) * $deathPoints;
	%kingWins = getTeamKingWins(%team) * $kingWonBattle;
	%kingDied = getTeamKingKills(%team) * $kingExecuted;
	return (%kill + %crown + %kingWins) + (%death - %kingDied);
}

//----------------------------------------------------------------------
function initScoreBoard()
{
	deleteVariables("$ScoreBoard::PlayerColumn*");
	deleteVariables("$ScoreBoard::TeamColumn*");

	// Player ScoreBoard column headings
	$ScoreBoard::PlayerColumnHeader1 = *IDMULT_SCORE_SQUAD;
	$ScoreBoard::PlayerColumnHeader2 = *IDMULT_SCORE_SCORE;
	$ScoreBoard::PlayerColumnHeader3 = *IDMULT_SCORE_KING_KILLS;
	$ScoreBoard::PlayerColumnHeader4 = *IDMULT_SCORE_EXECUTIONS;
	$ScoreBoard::PlayerColumnHeader5 = *IDMULT_SCORE_CROWNS;
	$ScoreBoard::PlayerColumnHeader6 = "Is King";
	$ScoreBoard::PlayerColumnHeader7 = "Kills";
	$ScoreBoard::PlayerColumnHeader8 = "Deaths";

	// Player ScoreBoard column functions
	$ScoreBoard::PlayerColumnFunction1 = "getPlayerSquad";
	$ScoreBoard::PlayerColumnFunction2 = "getPlayerPoint";
	$ScoreBoard::PlayerColumnFunction3 = "getKingKills";
	$ScoreBoard::PlayerColumnFunction4 = "getKingExecutions";
	$ScoreBoard::PlayerColumnFunction5 = "getCrowns";
	$ScoreBoard::PlayerColumnFunction6 = "getKinged";
	$ScoreBoard::PlayerColumnFunction7 = "getPlayerKills";
	$ScoreBoard::PlayerColumnFunction8 = "getPlayerDeaths";

	if($server::TeamPlay == true)
	{
		
		// Team ScoreBoard column headings
		$ScoreBoard::TeamColumnHeader1 = *IDMULT_SCORE_SCORE;
		$ScoreBoard::TeamColumnHeader2 = *IDMULT_SCORE_PLAYERS;
		$ScoreBoard::TeamColumnHeader3 = "Executions";
		$ScoreBoard::TeamColumnHeader4 = "King Kills";
		$ScoreBoard::TeamColumnHeader5 = "Kills";
		$ScoreBoard::TeamColumnHeader6 = "Deaths";
		$ScoreBoard::TeamColumnHeader7 = "Crowns";

		// Team ScoreBoard column functions
		$ScoreBoard::TeamColumnFunction1 = "getTeamSquadPoints";
		$ScoreBoard::TeamColumnFunction2 = "getNumPlayersTeam";
		$ScoreBoard::TeamColumnFunction3 = "getTeamKingKills";
		$ScoreBoard::TeamColumnFunction4 = "getTeamKingWins";
		$ScoreBoard::TeamColumnFunction5 = "getTeamSquadKills";
		$ScoreBoard::TeamColumnFunction6 = "getTeamSquadDeaths";
		$ScoreBoard::TeamColumnFunction7 = "getTeamCrowns";
	}
	// tell server to process all the scoreboard definitions defined above
	serverInitScoreBoard();
}

//----------------------------------------------------------------------
// Return the numbers of players per team
function getNumPlayersTeam(%bits)
{
	tName = getTeamNameFromTeamId(%bits);
	%count = 0;
	%playerCount = playerManager::getPlayerCount();

	for(%p = 0; %p < %playerCount; %p++)
	{
		%player = playerManager::getPlayerNum(%p);
		%team = getTeam(%player);
      
		if(%team == %tName)
		{
			%count++;
		}      
	}
	return %count;
}

//----------------------------------------------------------------------